﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region

Sub Process_Globals
	Private smiley As Bitmap

'	'*************************************
	'MQTT
	'SERVICIO MQTT PARA CONEXION
	' AQUI ESTA EL USUARIO Y CONTRASENA
	'*************************************
	Private mqtt As MqttClient
	Private serializator As B4XSerializator
	Private user As String = "ogmgscjf"
	Private password As String = "R7XnV5P8sr3g"
	Private fm_topic As String
	Private intentos = 0 As Int
	'// SERVICIO EN AUTOMATICO
	Private lock As PhoneWakeState
	Private nid As Int = 1
	Private Tracking As Boolean
	'//
	 Dim timer1 As Timer
	'
	
End Sub

Sub Service_Create
	Try
		Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER 'we are handling it ourselves
		lock.PartialLock
		smiley = LoadBitmapResize(File.DirAssets, "smiley.png", 24dip, 24dip, False)
	Catch
		'Exceptions.RuntimeException("nService.Service_Create")
	End Try
End Sub

Sub conectar
	' INDENTIFICADOR UNICO
	Try
		fm_topic = Starter.fm_topic
		Log("conectando....")
	Catch
		Return
	End Try
	'*******************
	'MQTT INICIALIZAR
	'******************
	Dim clientId As String = Rnd(0, 999999999) & DateTime.Now 'create a unique id
	mqtt.Initialize("mqtt", "tcp://164.68.117.193:1883", clientId)
	Dim mo As MqttConnectOptions
	mo.Initialize(user, password)
	mqtt.Connect2(mo)
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
End Sub

'*************************************
'MQTT
'*************************************
Sub mqtt_Connected (Success As Boolean)
Try	
	If Success = False Then
		Log(LastException)
		Sleep(2000)
		intentos= intentos + 1
		If intentos = 3 Then
			Msgbox("Limites de Intentos de Conexion, Verifique su internet o plan de datos","")
			ExitApplication
		End If
		conectar
	Else
		mqtt.Subscribe("general", 0)
		ToastMessageShow("Server Conecting",True)
		Log("Conectado al QMTT")
	End If
Catch
End Try		
End Sub

Private Sub mqtt_MessageArrived (Topic As String, Payload() As Byte)
	Try
		mensaje_recibido(Topic,Payload)
	Catch
	End Try
End Sub



Sub enviar_a_MQQT_chat(men As List ,fm_topic_ As String)
	If mqtt.Connected = False Then Return
	mqtt.Publish(fm_topic_, serializator.ConvertObjectToBytes(men))
End Sub


Sub mensaje_recibido( Topic As String, Payload() As Byte)
	
	Dim obj As Object
	obj = serializator.ConvertBytesToObject(Payload)
	'If obj Is audio Then
		Dim mensajesllegado As List = obj
		CallSub2(B4XPages.MainPage,"suena_mensaje",mensajesllegado)
		
	'End If
	
	
End Sub

'
'Sub Service_Destroy
'
'End Sub
'
'Sub HighPriority_Notification
'
'	Dim FileName As String = "sonido.m4a"
'	File.Copy(File.DirAssets,FileName,Starter.provider.SharedFolder, FileName)
'	Dim n As NB6
'	n.Initialize("custom sound", Application.LabelName, "HIGH")
'	n.SmallIcon(LoadBitmapResize(File.DirAssets, "smiley.png", 32dip, 32dip, True))
'	'disable the default sound
'	n.SetDefaults(False, True, True)
'	'set custom sound
'	n.CustomSound(Starter.Provider.GetFileUri(FileName))
'	Dim Notification As Notification = n.Build("Importante!!!", "Solicitud de Viaje Entrante", "tag", Recibir_Servicio)
'	Notification.Notify(3)
'	
'End Sub
'
Sub HighPriority_Notification

	Dim n As NB6
	n.Initialize("custom sound", Application.LabelName, "HIGH")
	n.SmallIcon(LoadBitmapResize(File.DirAssets, "logo72x72.png", 32dip, 32dip, True))
	Dim Notification As Notification = n.Build("Ubik => Chat",$"Ha llegado un mensaje..."$, "tag",Me)
	Notification.Notify(3)
	
End Sub
'
'
'
''======================================================
''============ FACTURA POR CORREO ======================
''======================================================
'
'Sub inicializa_correo
'	SMTP.Initialize("smtpout.secureserver.net", 465, "notificaciones_gps@iqaplicaciones.com", "Jlg10644263*", "SMTP")
'	SMTP.Sender = "notificaciones_gps@iqaplicaciones.com" '<---- This setting.
'	SMTP.UseSSL = True
'End Sub
'
'Sub enviar_factura_correo
'	inicializa_correo
'	enviar_correo
'	enviar_correo_driver
'End Sub
'
'Sub enviar_correo
'	Try
'		
'		DateTime.SetTimeZone(DateTime.TimeZoneOffset)
'		Dim hora As String
'		Dim fecha As String
'		fecha = DateTime.Date(DateTime.Now)
'	
'		SMTP.To.Add(Mapa.mensaje_Email_factura.correo)
'		SMTP.HtmlBody=True
'		SMTP.Body = SMTP.Body.Replace("=", "=3D")
'		SMTP.Subject =$"Recibos TakeTaxi. Viaje del ${Mapa.mensaje_Email_factura.fecha} a las ${Mapa.mensaje_Email_factura.hora} "$
'		SMTP.Body   = $"<H3>${Mapa.mensaje_Email_factura.tarifa} </H3> <br/>
'						Gracias por elegir TakeTaxi, ${Mapa.mensaje_Email_factura.nombre}<br/><br/>
'
'						Salida  | ${Mapa.mensaje_Email_factura.direccion_partida}	   <br/>		
'						Llegada | ${Mapa.mensaje_Email_factura.direccion_llegada}	   <br/><br/>
'															
'						Viajaste con ${Main.nombre_}	<br/><br/>
'
'						<b>${Mapa.mensaje_Email_factura.distancia.Replace("$","")} </b> kilómetros<br/>
'						<b>${Mapa.mensaje_Email_factura.tiempoViaje.Replace("Time:","")}</b> Tiempo del viaje <br/><br/>
'
'						TakeTaxi Auto<br/><br/>
'
'						La tarifa no incluye los cargos que puede cobrar tu banco. <br/>
'						Si tienes preguntas, consulta directamente a tu banco. 		<br/><br/>			
'
'						<b>TU TARIFA </b>   <br/><br/>
'						<b>Tarifa base</b>  ${Mapa.mensaje_Email_factura.tarifaMinima} 	<br/>
'						<b>Distancia</b> 	${Mapa.mensaje_Email_factura.distancia} 	<br/>
'						<b>Tiempo</b> 	    ${Mapa.mensaje_Email_factura.precioTiempo} 	<br/>
'						<b>Subtotal</b> 	${Mapa.mensaje_Email_factura.tarifa} 	<br/><br/>
'			
'						<b>cobrado</b>	${Mapa.mensaje_Email_factura.tarifa} Efectivo	<br/><br/>
'
'						Visita la página de viajes para más información.<br/>"$
'		SMTP.Body = SMTP.Body.Replace("=", "=3D")
'		SMTP.Send
'	Catch
'		
'	End Try
'	    
'End Sub
'
'
'Sub enviar_correo_driver
'	Try
'		
'		DateTime.SetTimeZone(DateTime.TimeZoneOffset)
'		Dim hora As String
'		Dim fecha As String
'		fecha = DateTime.Date(DateTime.Now)
'	
'		SMTP.To.Add(Mapa.correo_driver_public)
'		SMTP.HtmlBody=True
'		SMTP.Body = SMTP.Body.Replace("=", "=3D")
'		SMTP.Subject =$"Control TakeTaxi Viaje del ${Mapa.mensaje_Email_factura.fecha} a las ${Mapa.mensaje_Email_factura.hora} "$
'		SMTP.Body   = $"<H3>${Mapa.mensaje_Email_factura.tarifa} </H3> <br/>
'						Facturado a: ${Mapa.mensaje_Email_factura.nombre}<br/><br/>
'
'						Salida  | ${Mapa.mensaje_Email_factura.direccion_partida}	   <br/>		
'						Llegada | ${Mapa.mensaje_Email_factura.direccion_llegada}	   <br/><br/>
'												
'						<b>${Mapa.mensaje_Email_factura.distancia.Replace("$","")} </b> kilómetros<br/>
'						<b>${Mapa.mensaje_Email_factura.tiempoViaje.Replace("Time:","")}</b> Tiempo del viaje <br/><br/>
'
'		
'						La tarifa no incluye los cargos que puede cobrar tu banco. <br/>
'						Si tienes preguntas, consulta directamente a tu banco. 		<br/><br/>			
'
'						<b>TU FACTURA FUE: </b>   <br/><br/>
'						<b>Tarifa base</b>  ${Mapa.mensaje_Email_factura.tarifaMinima} 	<br/>
'						<b>Distancia</b> 	${Mapa.mensaje_Email_factura.distancia} 	<br/>
'						<b>Tiempo</b> 	    ${Mapa.mensaje_Email_factura.precioTiempo} 	<br/>
'						<b>Subtotal</b> 	${Mapa.mensaje_Email_factura.tarifa} 	<br/><br/>
'			
'						<b>cobrado</b>	${Mapa.mensaje_Email_factura.tarifa} Efectivo	<br/><br/>
'
'						Visita la página de viajes para más información.<br/>"$
'		SMTP.Body = SMTP.Body.Replace("=", "=3D")
'		SMTP.Send
'	Catch
'		
'	End Try
'	    
'End Sub
'
'Sub SMTP_MessageSent(Success As Boolean)
'	Mapa.mensaje_Email_factura.Initialize
'	Log(Success)
'	If Success Then
'		Log("Message sent successfully")
'	Else
'		Log("Error sending message")
'		Log(LastException.Message)
'	End If
'	
'	
'End Sub


'Sub enviar_a_MQQT(MapaMensaje As MensajeServicioCurrent ,cod_app As String)
'	If mqtt.Connected = False Then Return
'	Dim obj As Object
'	obj = serializator.ConvertObjectToBytes(MapaMensaje)
'	Dim obj1 As Object
'	obj1 = serializator.ConvertBytesToObject(obj)
'	mqtt.Publish("Master", serializator.ConvertObjectToBytes(MapaMensaje))
'End Sub
'
'
'Sub enviar_a_MQQT_comienza(MapaMensaje As mensaje_begin ,cod_app As String)
'	If mqtt.Connected = False Then Return
'	Dim obj As Object
'	obj = serializator.ConvertObjectToBytes(MapaMensaje)
'	Dim obj1 As Object
'	obj1 = serializator.ConvertBytesToObject(obj)
'	
'	'===============
'	'REMPLAZAR EL SIGNO + CUANDO ES UN DISPACHET
'	MapaMensaje.fm = MapaMensaje.fm.Replace("+","")
'	mqtt.Publish(MapaMensaje.fm, serializator.ConvertObjectToBytes(MapaMensaje))
'	notificar_viaje_en_camino_a_master
'End Sub
'
'Sub notificar_viaje_en_camino_a_master
'
'    Dim mensaje_enruta_master As mensaje_encamino_master
'
'	mensaje_enruta_master.id_servicio =  Pick_up_Pasajero.id_ser_public
'	mensaje_enruta_master.codigo_app = Main.COD_APP
'	
'	If mqtt.Connected = False Then Return
'	Dim obj As Object
'	obj = serializator.ConvertObjectToBytes(mensaje_enruta_master)
'	Dim obj1 As Object
'	obj1 = serializator.ConvertBytesToObject(obj)
'
'	mqtt.Publish("Master", serializator.ConvertObjectToBytes(mensaje_enruta_master))
'	
'End Sub
'
'Sub enviar_a_MQQT_factura(MapaMensaje As mensaje_factura,cod_app As String)
'	If mqtt.Connected = False Then Return
'	Dim obj As Object
'	obj = serializator.ConvertObjectToBytes(MapaMensaje)
'	Dim obj1 As Object
'	obj1 = serializator.ConvertBytesToObject(obj)
'	
'	'===============
'	'REMPLAZAR EL SIGNO + CUANDO ES UN DISPACHET
'	MapaMensaje.fm = MapaMensaje.fm.Replace("+","")
'	mqtt.Publish(MapaMensaje.fm, serializator.ConvertObjectToBytes(MapaMensaje))
'	notificar_fin_de_viaje_al_master
'	'==================
'	'==ENVIAR CORREO===
'	'==================
'	 enviar_factura_correo
'	'==================
'End Sub
'
'
'Sub notificar_fin_de_viaje_al_master
'
'	Dim mensaje_fi_viaje As mensaje_finalizado_el_servicio
'
'	mensaje_fi_viaje.id_servicio =  Pick_up_Pasajero.id_ser_public
'	mensaje_fi_viaje.codigo_app = Main.COD_APP
'	
'	If mqtt.Connected = False Then Return
'	Dim obj As Object
'	obj = serializator.ConvertObjectToBytes(mensaje_fi_viaje)
'	Dim obj1 As Object
'	obj1 = serializator.ConvertBytesToObject(obj)
'
'	mqtt.Publish("Master", serializator.ConvertObjectToBytes(mensaje_fi_viaje))
'	
'End Sub
'
